///////////////////////////////////////////////////////////////////////////////
//
//  CodeJock.DockingPane
//
//  Notes:
//  This doesn't work with Xbase++ SL1
//  Other problems exist too.  Still working on this one.
//
///////////////////////////////////////////////////////////////////////////////

#INCLUDE "dcdialog.CH"
#INCLUDE "XCodeJock.CH"
#INCLUDE "DockingPane.ch"
#INCLUDE "CJbitmap.CH"

FUNCTION Main()

LOCAL GetList[0], GetOptions, oDockingPane, oStatic, oGroupThemes, bAction, ;
      nTheme, oDesktop := AppDeskTop(), aWindows[6,3], aDir, oBrowse, ;
      oButton, oStatic3, nPointer

wtf 'start'

nTheme := ThemeDefault
aDir := Directory()

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 100,30 OBJECT oStatic ;
      RESIZE DCGUI_RESIZE_RESIZEONLY COLOR nil, GRA_CLR_WHITE ;
      CAPTION '..\..\..\bitmaps\wizard.bmp' ;
      PREEVAL {|o|o:options := XBPSTATIC_BITMAP_SCALED}

CJDOCKINGPANE oDockingPane ;
      PARENT oStatic ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      VISUALTHEME ThemeVisio ;
      SCALEMODE xtpScalePixel

@  0,0 DCSAY 'This is a Yellow Window' COLOR nil, GRA_CLR_YELLOW ;
   FONT '16.Arial Bold' ;
   OBJECT aWindows[1,1] SAYWORDBREAK PARENT oStatic ;
   EVAL {|o|o:hide(),aWindows[1,2] := o:getHwnd(), ;
            o:resize := {|a,b,o|ResizeWindow1(a,b,o)}}

@  0,0 DCSAY 'This is a Green Window' COLOR nil, GRA_CLR_GREEN ;
   FONT '16.Arial Bold' ;
   OBJECT aWindows[2,1] SAYWORDBREAK PARENT oStatic ;
   EVAL {|o|aWindows[2,2] := o:getHwnd(), ;
            o:resize := {|a,b,o|ResizeWindow2(a,b,o,oBrowse)}}

@ 40,10 DCBROWSE oBrowse DATA aDir SIZE 300,400 FIT PIXEL ;
       PARENT aWindows[2,1] FONT '8.Helv' ;
       POINTER nPointer ;
       ITEMSELECTED {||MsgBox('You chose '+ aDir[nPointer,1])}

DCBROWSECOL ELEMENT 1 HEADER 'File' PARENT oBrowse WIDTH 10
DCBROWSECOL ELEMENT 2 HEADER 'Size' PARENT oBrowse WIDTH 10

@ 0, 102 DCGROUP oGroupThemes CAPTION 'Visual Themes' SIZE 20,16 ;
      RESIZE DCGUI_RESIZE_REPOSONLY

bAction := {||oDockingPane:visualTheme := nTheme}
DCSETPARENT TO oGroupThemes
@ 2,1 DCRADIO nTheme VALUE ThemeDefault PROMPT 'Default' ACTION bAction
@ 3,1 DCRADIO nTheme VALUE ThemeOffice PROMPT 'Office' ACTION bAction
@ 4,1 DCRADIO nTheme VALUE ThemeOffice2003 PROMPT 'Office 2003' ACTION bAction
@ 5,1 DCRADIO nTheme VALUE ThemeNativeWinXP PROMPT 'Win XP' ACTION bAction
@ 6,1 DCRADIO nTheme VALUE ThemeGrippered PROMPT 'Grippered' ACTION bAction
@ 7,1 DCRADIO nTheme VALUE ThemeVisio PROMPT 'Visio' ACTION bAction
@ 8,1 DCRADIO nTheme VALUE ThemeWhidbey PROMPT 'Whidbey' ACTION bAction
@ 9,1 DCRADIO nTheme VALUE ThemeShortcutBar2003 PROMPT 'ShortcutBar 2003' ACTION bAction
@10,1 DCRADIO nTheme VALUE ThemeExplorer PROMPT 'Explorer' ACTION bAction
@11,1 DCRADIO nTheme VALUE ThemeVisualStudio2005 PROMPT 'Visual Studio 2005' ACTION bAction
@12,1 DCRADIO nTheme VALUE ThemeOffice2007 PROMPT 'Office 2007' ACTION bAction
@13,1 DCRADIO nTheme VALUE ThemeWord2007 PROMPT 'Word 2007' ACTION bAction
@14,1 DCRADIO nTheme VALUE ThemeOutlook2007 PROMPT 'Outlook 2007' ACTION bAction

DCSETPARENT TO

DCGETOPTIONS RESIZE
DCREAD GUI FIT TITLE 'CodeJock.DockingPane Sample' OPTIONS GetOptions ;
   EVAL {|o|BuildPanes(oDockingPane,aWindows,GetList)}


RETURN nil

* ------------

PROC appsys ; RETURN

* ------------

STATIC FUNCTION BuildPanes( oDockingPane, aWindows, aGetList )

LOCAL oPane, oStatic, GetList[0], GetOptions, aDir, oBrowse, nPointer

CJCreatePane oPane ;
  TITLE 'I am Yellow' ;
  TABCOLOR GRA_CLR_YELLOW ;
  ICON '..\..\..\bitmaps\design.bmp'  ;
  WINDOW aWindows[1] ;
  PARENT oDockingPane ;
  SIZE 400, 400 ;
  DIRECTION DockLeftOf ;
  ID 1

CJCreatePane oPane ;
  TITLE 'I am Green' ;
  TABCOLOR GRA_CLR_GREEN ;
  ICON '..\..\..\bitmaps\bug.bmp'  ;
  WINDOW aWindows[2] ;
  PARENT oDockingPane ;
  SIZE 400, 400 ;
  DIRECTION DockLeftOf ;
  ID 2

RETURN nil

* ----------------

STATIC FUNCTION ResizeWindow1( aOldSize, aNewSize, oStatic )

oStatic:invalidateRect()

RETURN nil

* ----------------

STATIC FUNCTION ResizeWindow2( aOldSize, aNewSize, oStatic, oBrowse )

oBrowse:setPos({0,0})
oBrowse:setSize({oStatic:currentSize()[1],oStatic:currentSize()[2]-40})
oStatic:invalidateRect()

RETURN nil
